;;; This file was automatically generated by SWIG (http://www.swig.org).
;;; Version 1.3.40
;;;
;;; Do not make changes to this file unless you know what you are doing--modify
;;; the SWIG interface file instead.

(in-package :llvm)


(cffi:defcfun ("LLVMLinkInJIT" LLVMLinkInJIT) :void)

(cffi:defcfun ("LLVMLinkInInterpreter" LLVMLinkInInterpreter) :void)

(cffi:defctype LLVMGenericValueRef :pointer)

(cffi:defctype LLVMExecutionEngineRef :pointer)

(cffi:defcfun ("LLVMCreateGenericValueOfInt" LLVMCreateGenericValueOfInt) LLVMGenericValueRef
  (Ty LLVMTypeRef)
  (N :unsigned-long-long)
  (IsSigned :boolean))

(cffi:defcfun ("LLVMCreateGenericValueOfPointer" LLVMCreateGenericValueOfPointer) LLVMGenericValueRef
  (P :pointer))

(cffi:defcfun ("LLVMCreateGenericValueOfFloat" LLVMCreateGenericValueOfFloat) LLVMGenericValueRef
  (Ty LLVMTypeRef)
  (N :double))

(cffi:defcfun ("LLVMGenericValueIntWidth" LLVMGenericValueIntWidth) :unsigned-int
  (GenValRef LLVMGenericValueRef))

(cffi:defcfun ("LLVMGenericValueToInt" LLVMGenericValueToInt) :unsigned-long-long
  (GenVal LLVMGenericValueRef)
  (IsSigned :boolean))

(cffi:defcfun ("LLVMGenericValueToPointer" LLVMGenericValueToPointer) :pointer
  (GenVal LLVMGenericValueRef))

(cffi:defcfun ("LLVMGenericValueToFloat" LLVMGenericValueToFloat) :double
  (TyRef LLVMTypeRef)
  (GenVal LLVMGenericValueRef))

(cffi:defcfun ("LLVMDisposeGenericValue" LLVMDisposeGenericValue) :void
  (GenVal LLVMGenericValueRef))

(cffi:defcfun ("LLVMCreateExecutionEngine" LLVMCreateExecutionEngine) :boolean
  (OutEE :pointer)
  (MP LLVMModuleProviderRef)
  (OutError :pointer))

(cffi:defcfun ("LLVMCreateInterpreter" LLVMCreateInterpreter) :boolean
  (OutInterp :pointer)
  (MP LLVMModuleProviderRef)
  (OutError :pointer))

(cffi:defcfun ("LLVMCreateJITCompiler" %LLVMCreateJITCompiler) :boolean
  (OutJIT :pointer)
  (MP LLVMModuleProviderRef)
  (OptLevel :unsigned-int)
  (OutError :pointer))

(cffi:defcfun ("LLVMDisposeExecutionEngine" LLVMDisposeExecutionEngine) :void
  (EE LLVMExecutionEngineRef))

(cffi:defcfun ("LLVMRunStaticConstructors" LLVMRunStaticConstructors) :void
  (EE LLVMExecutionEngineRef))

(cffi:defcfun ("LLVMRunStaticDestructors" LLVMRunStaticDestructors) :void
  (EE LLVMExecutionEngineRef))

(cffi:defcfun ("LLVMRunFunctionAsMain" LLVMRunFunctionAsMain) :int
  (EE LLVMExecutionEngineRef)
  (F LLVMValueRef)
  (ArgC :unsigned-int)
  (ArgV :pointer)
  (EnvP :pointer))

(cffi:defcfun ("LLVMRunFunction" LLVMRunFunction) LLVMGenericValueRef
  (EE LLVMExecutionEngineRef)
  (F LLVMValueRef)
  (NumArgs :unsigned-int)
  (Args :pointer))

(cffi:defcfun ("LLVMFreeMachineCodeForFunction" LLVMFreeMachineCodeForFunction) :void
  (EE LLVMExecutionEngineRef)
  (F LLVMValueRef))

(cffi:defcfun ("LLVMAddModuleProvider" LLVMAddModuleProvider) :void
  (EE LLVMExecutionEngineRef)
  (MP LLVMModuleProviderRef))

(cffi:defcfun ("LLVMRemoveModuleProvider" LLVMRemoveModuleProvider) :boolean
  (EE LLVMExecutionEngineRef)
  (MP LLVMModuleProviderRef)
  (OutMod :pointer)
  (OutError :pointer))

(cffi:defcfun ("LLVMFindFunction" LLVMFindFunction) :boolean
  (EE LLVMExecutionEngineRef)
  (Name :string)
  (OutFn :pointer))

(cffi:defcfun ("LLVMGetExecutionEngineTargetData" LLVMGetExecutionEngineTargetData) LLVMTargetDataRef
  (EE LLVMExecutionEngineRef))

(cffi:defcfun ("LLVMAddGlobalMapping" LLVMAddGlobalMapping) :void
  (EE LLVMExecutionEngineRef)
  (Global LLVMValueRef)
  (Addr :pointer))

(cffi:defcfun ("LLVMGetPointerToGlobal" LLVMGetPointerToGlobal) :pointer
  (EE LLVMExecutionEngineRef)
  (Global LLVMValueRef))


(defun LLVMCreateJITCompiler (provider opt)
  (cffi:with-foreign-objects ((out-engine :pointer)
                              (out-error-str :pointer))
    (if (null (%LLVMCreateJITCompiler out-engine provider opt out-error-str))
        (cffi:mem-ref out-engine :pointer)
        (let* ((error-str (cffi:mem-ref out-error-str :pointer))
               (error-str-lisp (cffi:foreign-string-to-lisp error-str)))
          (LLVMDisposeMessage error-str)
          (error "LLVMCreateJITCompiler: ~s" error-str-lisp)))))




